#ifndef MAC_PHY_TEST_H
#define MAC_PHY_TEST_H

#include <xtemac.h>

//Ethernet device ID
#define DEVICE_ID       XPAR_PLB_TEMAC_0_DEVICE_ID
//Maximum Ethernet frame size in word length
#define XTE_MAX_FRAME_SIZE_IN_WORDS ((XTE_MAX_FRAME_SIZE /sizeof(Xuint32)) + 1)

/******************* Gobal Variable Definitions *****************************/
static Xboolean FullDuplex = XTRUE;
static Xboolean FastEthernet = XTRUE; //100BaseT Mode

static Xuint8 LocalAddress[XTE_MAC_ADDR_SIZE] = {
    0x00, 0x11, 0x22, 0x33, 0x44, 0x55 };

/******************* Function Definitions **********************************/
int  emac_mfg_test(void);
int  emac_init(XTemac *InstancePtr, Xuint16 DeviceId);
int  emac_setMACOptions(XTemac *InstancePtr, Xuint32 Options);
int  emac_selfTest(XTemac *InstancePtr);

int  emac_loopBackFrame(XTemac *InstancePtr, Xuint32 PayloadSize);
int  emac_sendFrame(XTemac *InstancePtr, Xuint32 PayloadSize, Xuint8 *DestAddress);
int  emac_receiveFrame(XTemac *InstancePtr, Xuint32 PayloadSize, Xboolean Verify);

int  emac_phyTest(XTemac *InstancePtr, Xuint8 PhyAddress);
int  emac_phyLoopBackTest(XTemac *InstancePtr);
int  emac_setPHYOptions(XTemac *InstancePtr, Xboolean loopBack);
#endif
