/*
 *  * Copyright (c) 2004 Xilinx, Inc.  All rights reserved.
 *
 * Xilinx, Inc.
 * XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS" AS A 
 * COURTESY TO YOU.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION AS
 * ONE POSSIBLE   IMPLEMENTATION OF THIS FEATURE, APPLICATION OR 
 * STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS IMPLEMENTATION 
 * IS FREE FROM ANY CLAIMS OF INFRINGEMENT, AND YOU ARE RESPONSIBLE 
 * FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE FOR YOUR IMPLEMENTATION
 * XILINX EXPRESSLY DISCLAIMS ANY WARRANTY WHATSOEVER WITH RESPECT TO 
 * THE ADEQUACY OF THE IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO 
 * ANY WARRANTIES OR REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE 
 * FROM CLAIMS OF INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY 
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * Xilinx EDK 8.1 EDK_I.18.7
 *
 * This file is a sample test application
 *
 * This application is intended to test and/or illustrate some 
 * functionality of your system.  The contents of this file may
 * vary depending on the IP in your system and may use existing
 * IP driver functions.  These drivers will be generated in your
 * XPS project when you run the "Generate Libraries" menu item
 * in XPS.
 *
 * Your XPS project directory is at:
 *    C:\xil_proj\8_1\EDK_NHFX12_noDDR\
 */


// Located in: ppc405_0/include/xparameters.h
#include "xparameters.h"

#include "stdio.h"

#include "xutil.h"

//====================================================

XStatus Flash_Reset(void)
{
	 Xuint32 RD_RST_DATA = 0x00F000F0;
	 Xuint32 *write_add;
	 Xuint32 *read_add;
	 Xuint32 temp, word;

	temp = 0;
	
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x555;
	/* 1st Cycle   */
	*write_add = 0x00AA00AA;
	
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x2AA;
	/* 2nd Cycle   */
	*write_add = 0x00550055;
	
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x000;
	/* 3rd Cycle   */
	*write_add = 0x00F000F0;
	
//	print("\n\rExiting Flash_Reset\n\r");
	
   return XST_SUCCESS;
}

XStatus Flash_Autoselect(void)
{
	 Xuint32 *write_add;

/* Place device in Auto Select mode  */
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x555;
	/* 1st Cycle   */
	*write_add = 0x00AA00AA;
	
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x2AA;
	/* 2nd Cycle   */
	*write_add = 0x00550055;
	
	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x555;
	/* 3rd Cycle   */
	*write_add = 0x00900090;

//	print("Exiting Flash_Autoselect\n\r");
	
   return XST_SUCCESS;
}

XStatus Flash_Read_2words(Xuint32 *Addr)
{
    Xuint32 word;
	
	word = Addr[0];
//	xil_printf("Flash Device ID = 0x%X\r\n", word);
	if (word == 0x227e2273) 
		return XST_MEMTEST_FAILED;
		
	word = Addr[1];
	
	if (word != 0x227e2273)
		return XST_MEMTEST_FAILED;
	else
		return XST_SUCCESS;

}

XStatus Flash_Test(Xuint32 *Addr)
{
	 Xuint32 RD_RST_DATA = 0x00F000F0;
	 Xuint32 *write_add;
	 Xuint32 *address;
	 Xuint32 *read_add;
	 Xuint32 temp;
	 Xuint32 Val;
	 Xuint32 Words;
	 Xuint32 word1;
	 Xuint32 i;
	 Xuint32 Word;


	temp = 0;
	Words = 32;
	
//	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x555;
//	/* 1st Cycle   */
//	*write_add = 0x00AA00AA;
//	
//	write_add = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x2AA;
//	/* 2nd Cycle   */
//	*write_add = 0x00550055;
//	
//	address = XPAR_FLASH_4MX32_MEM0_BASEADDR + 0x000;
//	/* 3rd Cycle   */
	Val = 0x00F000F0;
//	for (i = 0L; i < Words; i++)
//            {
//                Addr[i] = Val;
//
//                /* write memory location */
//
//                Val++;
//            }
				
	Val = 0x00F000F0;
	for (i = 0L; i < 64; i++)
            {
					Word = 0;
                Word = Addr[i];
					 if (i == 0) xil_printf("\n\ri=0, data = 0x%x\n\r",Word);
					 if (i == 1) xil_printf("i=1, data = 0x%x\n\r",Word);
					 if (i == 2) xil_printf("i=2, data = 0x%x\n\r",Word);
					 if (i == 3) xil_printf("i=3, data = 0x%x\n\r",Word);
                if (Word == Val)
                {
                    return XST_MEMTEST_FAILED; 
                }

                Val++;
            }
				print("\n\r\n\r");
	return XST_SUCCESS;
	 
}

XStatus Flash_Manuf_Device(Xuint32 *Addr)
{
	 Xuint32 i;
	 Xuint32 Word;
	 Xuint32 count;

	i = 0L;
	count = 0;
	Word = Addr[i];
	if (Word == i) count++;
//	xil_printf("\n\rAddress = 0x%x, data = 0x%x\n\r",i,Word);
	i = 1L;
	Word = Addr[i];
	if (Word == i) count++;
//	xil_printf("Address = 0x%x, data = 0x%x\n\r",i,Word);
	i = 14L;
	Word = Addr[i];
	if (Word == i) count++;
//	xil_printf("Address = 0x%x, data = 0x%x\n\r",i,Word);
	i = 15L;
	Word = Addr[i];
	if (Word == i) count++;
//	xil_printf("Address = 0x%x, data = 0x%x\n\r",i,Word);
	
	return count;
	 
}

int main (void) {

	XStatus status;
	Xuint32 *read_add;
   Xuint32 word;
	Xuint32 count;
	char input;
   print("-- Entering main() --\r\n");
		count = 0;
		status = Flash_Manuf_Device(XPAR_FLASH_4MX32_MEM0_BASEADDR);
		
		status = Flash_Reset();
		if (status == XST_SUCCESS) 
		{
			;
		}
		else
		{
         print("FAILED Reset!\r\n");
      }
		
//		status = Flash_Autoselect();	
//		if (status != XST_SUCCESS) 
//         print("FAILED!\r\n");
//
	
		//status = Flash_Read_2words(XPAR_FLASH_4MX32_MEM0_BASEADDR);
		while(1)
		{
			Flash_Autoselect();
			status = Flash_Manuf_Device(XPAR_FLASH_4MX32_MEM0_BASEADDR);
			if (status != XST_SUCCESS) {
				count++;
			}
			Flash_Reset();
			if (count == 100000) {
				print("\n\rpassed 100000!!!\n\r");
				count = 0;
				}
		}		

   print("-- Exiting main() --\r\n");
   return 0;
}




