#################################################################
# Makefile generated by Xilinx Platform Studio 
# Project:C:\Projects\FX12_Projects\FX12_BIST_Clean\system.xmp
#################################################################

XILINX_EDK_DIR = C:/EDK

SYSTEM = system

MHSFILE = system.mhs

MSSFILE = system.mss

FPGA_ARCH = virtex4

DEVICE = xc4vfx12sf363-12

LANGUAGE = vhdl

SEARCHPATHOPT = 

SUBMODULE_OPT = 

PLATGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT)

LIBGEN_OPTIONS = -mhs $(MHSFILE) -p $(DEVICE) $(SEARCHPATHOPT)

VPGEN_OPTIONS = -p $(DEVICE) $(SEARCHPATHOPT)

BIST_OUTPUT_DIR = BIST
BIST_OUTPUT = $(BIST_OUTPUT_DIR)/executable.elf

MICROBLAZE_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/microblaze/mb_bootloop.elf
PPC405_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc405/ppc_bootloop.elf
PPC440_BOOTLOOP = $(XILINX_EDK_DIR)/sw/lib/ppc440/ppc440_bootloop.elf
BOOTLOOP_DIR = bootloops

PPC405_0_BOOTLOOP = $(BOOTLOOP_DIR)/ppc405_0.elf

BRAMINIT_ELF_FILES =  $(BIST_OUTPUT) 
BRAMINIT_ELF_FILE_ARGS =   -pe ppc405_0 $(BIST_OUTPUT) 

ALL_USER_ELF_FILES = $(BIST_OUTPUT) 

SIM_CMD = vsim

BEHAVIORAL_SIM_SCRIPT = simulation/behavioral/$(SYSTEM).do

STRUCTURAL_SIM_SCRIPT = simulation/structural/$(SYSTEM).do

TIMING_SIM_SCRIPT = simulation/timing/$(SYSTEM).do

DEFAULT_SIM_SCRIPT = $(BEHAVIORAL_SIM_SCRIPT)

MIX_LANG_SIM_OPT = -mixed yes

SIMGEN_OPTIONS = -p $(DEVICE) -lang $(LANGUAGE) $(SEARCHPATHOPT) $(SUBMODULE_OPT) $(BRAMINIT_ELF_FILE_ARGS) $(MIX_LANG_SIM_OPT)  -s mti


LIBRARIES =  \
       ppc405_0/lib/libxil.a 
VPEXEC = virtualplatform/vpexec.exe

LIBSCLEAN_TARGETS = ppc405_0_libsclean 

PROGRAMCLEAN_TARGETS = BIST_programclean 

CORE_STATE_DEVELOPMENT_FILES = 

WRAPPER_NGC_FILES = implementation/ppc405_0_wrapper.ngc \
implementation/reset_block_wrapper.ngc \
implementation/plb_wrapper.ngc \
implementation/opb_wrapper.ngc \
implementation/plb2opb_wrapper.ngc \
implementation/leds_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_wrapper.ngc \
implementation/plb_bram_if_cntlr_1_bram_wrapper.ngc \
implementation/vgatest_0_wrapper.ngc \
implementation/opb_uartlite_0_wrapper.ngc \
implementation/char_lcd_wrapper.ngc \
implementation/daac_diff_io_wrapper.ngc \
implementation/dcm_0_wrapper.ngc \
implementation/dcm_1_wrapper.ngc \
implementation/dcm_1_clk90_inv_wrapper.ngc \
implementation/ddr_sdram_16mx32_wrapper.ngc \
implementation/flash_4mx32_wrapper.ngc \
implementation/flash_4mx32_util_bus_split_0_wrapper.ngc \
implementation/sysclk_inv_wrapper.ngc \
implementation/clk90_inv_wrapper.ngc \
implementation/jtagppc_0_wrapper.ngc \
implementation/ethernet_mac_wrapper.ngc

POSTSYN_NETLIST = implementation/$(SYSTEM).ngc

SYSTEM_BIT = implementation/$(SYSTEM).bit

DOWNLOAD_BIT = implementation/download.bit

SYSTEM_ACE = implementation/$(SYSTEM).ace

UCF_FILE = data/system.ucf

BMM_FILE = implementation/$(SYSTEM).bmm

BITGEN_UT_FILE = etc/bitgen.ut

XFLOW_OPT_FILE = etc/fast_runtime.opt
XFLOW_DEPENDENCY = __xps/xpsxflow.opt $(XFLOW_OPT_FILE)

FPGA_IMP_DEPENDENCY = $(BMM_FILE) $(POSTSYN_NETLIST) $(UCF_FILE) $(BITGEN_UT_FILE) $(XFLOW_DEPENDENCY)

#################################################################
# SOFTWARE APPLICATION BIST
#################################################################

BIST_SOURCES = BIST/src/main.c BIST/src/TestApp_Peripheral.c BIST/src/uart.c BIST/src/xrom_lcd.c BIST/src/flash.c BIST/src/ddr.c BIST/src/ping.c 

BIST_HEADERS = BIST/src/TestApp_Peripheral.h BIST/src/uart.h BIST/src/xrom_lcd.h BIST/src/ddr.h BIST/src/ping.h 

BIST_CC = powerpc-eabi-gcc
BIST_CC_SIZE = powerpc-eabi-size
BIST_CC_OPT = -O1
BIST_CFLAGS = 
BIST_CC_SEARCH = # -B
BIST_LIBPATH = -L./ppc405_0/lib/ # -L
BIST_INCLUDES = -I./ppc405_0/include/  -IBIST/src/ # -I
BIST_LFLAGS = # -l
BIST_CC_PREPROC_FLAG = # -Wp,
BIST_CC_ASM_FLAG = # -Wa,
BIST_CC_LINKER_FLAG = # -Wl,
BIST_LINKER_SCRIPT = 
BIST_LINKER_SCRIPT_FLAG = #-Wl,-T -Wl,$(BIST_LINKER_SCRIPT) 
BIST_CC_DEBUG_FLAG =  -g 
BIST_CC_PROFILE_FLAG = # -pg
BIST_CC_GLOBPTR_FLAG= # -msdata=eabi
BIST_CC_START_ADDR_FLAG=  # -Wl,-defsym -Wl,_START_ADDR=
BIST_CC_STACK_SIZE_FLAG=  # -Wl,-defsym -Wl,_STACK_SIZE=
BIST_CC_HEAP_SIZE_FLAG=  # -Wl,-defsym -Wl,_HEAP_SIZE=
BIST_OTHER_CC_FLAGS= $(BIST_CC_GLOBPTR_FLAG)  \
                  $(BIST_CC_START_ADDR_FLAG) $(BIST_CC_STACK_SIZE_FLAG) $(BIST_CC_HEAP_SIZE_FLAG)  \
                  $(BIST_CC_PREPROC_FLAG) $(BIST_CC_ASM_FLAG) $(BIST_CC_LINKER_FLAG)  \
                  $(BIST_LINKER_SCRIPT_FLAG) $(BIST_CC_DEBUG_FLAG) $(BIST_CC_PROFILE_FLAG) 
